function [ portfolio, newStateMatrix ] = pairTrading( decisionData, stateMatrix )
%% Խײ
%  ԭsearchPairSecurityѰϵ(Rtn)0.85ͨЭϵ(CP)ĹƱԣԹƱԵۼ
%            ȥĲпƽжϣȥĲСʮΪֵʮΪֵֺ
%            ĵʮΪƽֵֺ¼ֵƽֵȥĲͻƿֵʱ֣صֵ
%            ڼӲ֣ع鵽ƽֵʱƽ֡

   
   %% ֵ
   corrThreshold = 0.85;
   stockCP = decisionData.CP_DAY01.data;
   stockRtn = decisionData.Rtn_DAY01.data;
   stockList = decisionData.tickerList;

   %% ʼstateMatrix,positionʾÿֻ֤ȯĳֱֲindexǿֱǣ0ʾδ֣1ʾѿ
   if isempty(stateMatrix)
      portfolio   = zeros(length(decisionData.CP_DAY01.tickerList),1); 
      index    = 0;
      emptyDate    = 0;   %emptyDate¼ղֵղֵָɸѡԱ
      pairSecurity = {};    %ĿƱ
      close = 0;               %ƽֵֺƽֵڱ仯 
      open = 0;               %ֵֺпټӲ
      time = 0;                %100컹δƽֹ
   else
       portfolio = stateMatrix.portfolio;
       index = stateMatrix.index;
       pairSecurity = stateMatrix.pairSecurity;
       emptyDate = stateMatrix.emptyDate;
       close = stateMatrix.close;
       open = stateMatrix.open;
       time = stateMatrix.time;
   end
   if isempty(pairSecurity)     %searchPairSecurityѰԱĹƱ
      pairSecurity = searchPairSecurity(stockCP, stockRtn, stockList, corrThreshold);
      if isempty(pairSecurity) 
          newStateMatrix.portfolio = portfolio;
          newStateMatrix.index = index;
          newStateMatrix.emptyDate = emptyDate + 1;
          newStateMatrix.pairSecurity = pairSecurity;
          newStateMatrix.close = close ;
          newStateMatrix.open = open ;
          newStateMatrix.time = time;
          return;
      else
          [~,securityIndex] = ismember([pairSecurity{1,1},pairSecurity{1,2}],decisionData.CP_DAY01.tickerList);
      end
   else
          [~,securityIndex] = ismember([pairSecurity{1,1},pairSecurity{1,2}],decisionData.CP_DAY01.tickerList);
          if emptyDate >= 20
               pairSecurity = searchPairSecurity(stockCP, stockRtn, stockList, corrThreshold);
               if isempty(pairSecurity)
                   newStateMatrix.portfolio = portfolio;
                   newStateMatrix.index = index;
                   newStateMatrix.emptyDate = emptyDate + 1;
                   newStateMatrix.pairSecurity = pairSecurity ;
                   newStateMatrix.close = close ;
                   newStateMatrix.open = open ;
                   newStateMatrix.time = time;
                   return;
               else
                  [~,securityIndex] = ismember([pairSecurity{1,1},pairSecurity{1,2}],decisionData.CP_DAY01.tickerList);
               end
          end
   end
   %% ׹ãԲŻ£ûԶȥ 
   %RtnۼȥĲֵظ
   stockRtn_Pair = decisionData.Rtn_DAY01.data(securityIndex,:);
   stockList_Pair = decisionData.tickerList(securityIndex);
   stockCP_Pair = decisionData.CP_DAY01.data(securityIndex,end);
   stockID_Pair = getTradingCodeByOrgid(stockList_Pair,decisionData.time,decisionData.time);
   
   first =stockRtn_Pair(1,:);
   second = stockRtn_Pair(2,:);
   for i = 1:size(stockRtn_Pair,2)
        first_Acc(i) = sum(first(1:i));
        second_Acc(i) = sum(second(1:i));
   end
   mspread = first_Acc - second_Acc-mean(first_Acc - second_Acc);
   mspread_sort = sort(mspread);
   openSmall = mspread_sort(10);
   openBig = mspread_sort(90);
   closeTh = mspread_sort(50);
   
   r=regress(log10(stockCP(securityIndex(1),:))',log10(stockCP(securityIndex(2),:)'));
   %% ׹
   if  index== 0     
       %۲ֵʼԽ
       if mspread(end) < openSmall
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), '֡','λ',num2str(stockCP_Pair(1)),'룺',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = -0.2*r;
           portfolio(securityIndex(1), 1) = 0.2;
           index     = -0.5;
           emptyDate    = 0; 
           close = closeTh;
           open = openSmall;
           time = decisionData.time;
       elseif  mspread(end) > openBig
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), '֡','λ',num2str(stockCP_Pair(1)),'',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'룺',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = 0.2*r;
           portfolio(securityIndex(1), 1) = -0.2;
           index     = 0.5;
           emptyDate    = 0;
           close = closeTh;
           open = openBig;
           time = decisionData.time;
       else
           emptyDate = emptyDate + 1;
           close = 0;
           open =0;
           time = 0;
       end
   %ǰгֲֵ    
   else%Ӳ
       if (index== 0.5)&& (mspread(end) < open)
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), 'Ӳ֡','λ',num2str(stockCP_Pair(1)),'Ӳ֣',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'Ӳ֣',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = 0.2*r;
           portfolio(securityIndex(1), 1) = -0.2;
           index     = 1; 
       elseif (index== -0.5)&& (mspread(end) > open)
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), 'Ӳ֡','λ',num2str(stockCP_Pair(1)),'Ӳ֣',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'Ӳ֣',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = -0.2*r;
           portfolio(securityIndex(1), 1) = 0.2;
           index     = -1; 
       elseif (index== 1||index== 0.5)&& (mspread(end) < close)%ƽ
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), 'ƽ֡','λ',num2str(stockCP_Pair(1)),'ƽ֣',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'ƽ֣',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = 0;
           portfolio(securityIndex(1), 1) = 0;
           index     = 0;  
           emptyDate = 0;
           pairSecurity = {};
           close = 0;
           time = 0;
       elseif (index== -1||index== -0.5)&& (mspread(end) > close)
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), 'ƽ֡','λ',num2str(stockCP_Pair(1)),'ƽ֣',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'ƽ֣',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = 0;
           portfolio(securityIndex(1), 1) = 0;
           index     = 0;  
           emptyDate = 0;
           close = 0;
           pairSecurity = {};
           time = 0;
       elseif decisionData.time-time >100
           disp(['ڣ ', datestr(decisionData.time,'yyyy-mm-dd'), 'ֹ','λ',num2str(stockCP_Pair(1)),'ƽ֣',char(stockID_Pair(1,1)),'λ',num2str(stockCP_Pair(2)),'ƽ֣',char(stockID_Pair(2,1))]);
           portfolio(securityIndex(2), 1) = 0;
           portfolio(securityIndex(1), 1) = 0;
           index     = 0;  
           emptyDate = 0;
           pairSecurity = {};
           close = 0;
           time = 0;
      end
   end
   %% ״ֵ̬
          newStateMatrix.portfolio = portfolio;
          newStateMatrix.index = index;
          newStateMatrix.pairSecurity = pairSecurity;
          newStateMatrix.emptyDate = emptyDate;
          newStateMatrix.close = close;
          newStateMatrix.open = open;
          newStateMatrix.time = time;
end

function finalPair = searchPairSecurity(stockCP, stockRtn, stockList,corrThreshold)
    %%%˺ڹƱѰԱģҪЭϵ
    %Σ̼ۡʡƱбϵֵ
    % Σ
    %finalPair : ԺЭҪĹƱԣΪ1*3󣬷ҪԹƱУϵĹƱ
    %               һΪƱ1orgidڶΪƱ2orgidΪֻƱϵ
    disp('ѰԱ......');
    %ʼ
    corrPair = {};          %ϵֵĹƱ
    finalPair_temp = {}; %ϵֵЭĹƱ
    finalPair = {};          %ϵЭҪģϵĹƱ
    k=1;                       %ãΪcorrPairֵʱʹ
    finalNum = 1;         %ãΪfinalPair_tempֵʱʹ
    
    %% ϵ⣺ҳϵﵽֵĹƱ
     rhoMat = tril(corr(stockRtn'));
     [row,col] = find(rhoMat>= corrThreshold & rhoMat <1);
     if isempty(row)
        return;
     end  
     for i = 1:length(row)
         corrPair{k,1} = stockList(row(i));%orgidID
         corrPair{k,2} = stockList(col(i));
         corrPair{k,3} = rhoMat(row(i),col(i));%ϵ
         corrPair{k,4} = row(i);
         corrPair{k,5} = col(i);
         k = k+1;
     end

    %% Э飺ҪĹƱĶ۸нEngle-GrangerЭ飬ЭҪĹƱϢ        
    for m =1:size(corrPair,1)    %Ϊ׼
        if stockCP(corrPair{m,4},1) < stockCP(corrPair{m,5},1)
           t1 = corrPair{m,1};
           corrPair{m,1} = corrPair{m,2};
           corrPair{m,2} = t1;
           
           t2 = corrPair{m,4};
           corrPair{m,4} = corrPair{m,5};
           corrPair{m,5} = t2;
        end
        warning off
        % ޳δлеĹƱ
        if isnan(stockCP(corrPair{m,4}))==1 || isnan(stockCP(corrPair{m,5})) ==1
            continue;
        end
        % ޳ͣƹƱ
        if size(unique(stockCP(corrPair{m,4},:)))==1 | size(unique(stockCP(corrPair{m,5},:)))==1
            continue;
        end
        [h_cp,~,~,~,~,~] = egcitest(log10(stockCP([corrPair{m,4},corrPair{m,5}],:)'));
        if  h_cp == 1 %ȡЭΪ1ĹƱ
            finalPair_temp{finalNum,1} = corrPair{m,1};
            finalPair_temp{finalNum,2} = corrPair{m,2};
            finalPair_temp{finalNum,3} = corrPair{m,3};
            finalNum = finalNum + 1;
        end   
        
    end
    
    %% ѡֻЭϵĹƱ
    if size(finalPair_temp,1) ~= 1 && ~isempty(finalPair_temp)
        [~,r] = max(cell2mat(finalPair_temp(:,3)));
        finalPair{1,1} = finalPair_temp{r,1};
        finalPair{1,2} = finalPair_temp{r,2};
        finalPair{1,3} = finalPair_temp{r,3};
    elseif size(finalPair_temp,1) == 1
        finalPair{1,1} = finalPair_temp{1,1};
        finalPair{1,2} = finalPair_temp{1,2};
        finalPair{1,3} = finalPair_temp{1,3};
    end
end


